// Generated by CoffeeScript 1.12.7
(function() {
  var Moment, UPDATE, debug, escape, foot, handler, make_params, now, pkg, ref,
    hasProp = {}.hasOwnProperty;

  pkg = require('../../package');

  this.name = pkg.name + ":middleware:client:place-call";

  ref = (require('tangible'))(this.name), debug = ref.debug, foot = ref.foot;

  Moment = require('moment-timezone');

  UPDATE = require('red-rings/operations').UPDATE;

  escape = function(v) {
    return ("" + v).replace(',', ',');
  };

  make_params = function(data) {
    var k, v;
    return ((function() {
      var results;
      results = [];
      for (k in data) {
        if (!hasProp.call(data, k)) continue;
        v = data[k];
        results.push(k + "=" + (escape(v)));
      }
      return results;
    })()).join(',');
  };

  now = function(tz) {
    if (tz == null) {
      tz = 'UTC';
    }
    return Moment().tz(tz).format();
  };

  this.handler = handler = function(cfg) {
    var Reference, call_to_conference, client_server, context, create_queuer_call, elected, host, local_server, p, place_call, port, profile, ref1, ref2, ref3, ref4, ref5, ref6, socket_port, sofia_profile;
    if (cfg.local_redis_client != null) {
      elected = function(key) {
        var name, winner;
        name = "elected-" + key;
        winner = await(cfg.local_redis_client).setnx(name, false)["catch"](function() {
          return null;
        });
        if (winner) {
          await(cfg.local_redis_client).expire(name, 60)["catch"](function() {
            return true;
          });
        } else {
          debug('Lost the election.');
        }
        return winner;
      };
    } else {
      elected = function() {
        return Promise.resolve(true);
      };
    }
    profile = (ref1 = cfg.session) != null ? ref1.profile : void 0;
    if (profile == null) {
      debug.dev('Missing cfg.session.profile, not starting.');
      return;
    }
    sofia_profile = "huge-play-" + profile + "-egress";
    context = profile + "-egress";
    host = cfg.host;
    p = (ref2 = cfg.profiles) != null ? ref2[profile] : void 0;
    if (host && (p != null)) {
      port = (ref3 = p.egress_sip_port) != null ? ref3 : p.sip_port + 10000;
      socket_port = (ref4 = p.socket_port) != null ? ref4 : 5721;
    } else {
      debug('Missing cfg.host or cfg.profiles[profile], not starting.', {
        profile: profile
      });
      return;
    }
    local_server = cfg.host + ":" + ((ref5 = p.ingress_sip_port) != null ? ref5 : p.sip_port);
    client_server = cfg.host + ":" + ((ref6 = p.egress_sip_port) != null ? ref6 : p.sip_port + 10000);
    debug('Using', {
      local_server: local_server,
      client_server: client_server
    });
    Reference = cfg.Reference;
    place_call = foot(function(data) {
      var _id, account, argv, caller, cmd, command, domain, endpoint, endpoint_data, is_remote, my_reference, params, ref7, res, sofia, timezone, xref;
      endpoint = data.endpoint, caller = data.caller, _id = data._id;
      if (data.callee_name == null) {
        data.callee_name = pkg.name;
      }
      if (data.callee_num == null) {
        data.callee_num = data.destination;
      }
      debug('Received place-call', data);
      if (!((_id != null) && _id.match(/^[\w-]+$/))) {
        return;
      }
      endpoint_data = await(cfg.prov.get("endpoint:" + endpoint)["catch"](function() {
        return null;
      }));
      if (endpoint_data == null) {
        return;
      }
      if (endpoint_data.disabled || endpoint_data.src_disabled) {
        return;
      }
      account = endpoint_data.account, timezone = endpoint_data.timezone;
      domain = endpoint_data.number_domain;
      if (domain == null) {
        return;
      }
      is_remote = await(cfg.is_remote(domain, [local_server, client_server].join('/'))["catch"](function() {
        return true;
      }));
      if (is_remote) {
        return;
      }
      debug('place-call: Placing call');
      my_reference = new Reference(_id);
      await(my_reference.add_in(["endpoint:" + endpoint, "account:" + account, "number_domain:" + domain]));
      await(my_reference.set_account(account));
      await(my_reference.set_destination(data.destination));
      xref = "xref=" + _id;
      params = make_params({
        session_reference: _id,
        origination_context: context,
        sip_invite_params: xref,
        sip_invite_to_params: xref,
        sip_invite_contact_params: xref,
        sip_invite_from_params: xref,
        'sip_h_X-En': data.endpoint
      });
      sofia = "{" + params + "}sofia/" + sofia_profile + "/sip:" + caller;
      command = "socket(127.0.0.1:" + socket_port + " async full)";
      argv = [sofia, "'&" + command + "'", 'none', context, data.callee_name, data.callee_num, (ref7 = data.call_timeout) != null ? ref7 : ''].join(' ');
      cmd = "originate " + argv;
      if (!await(elected(_id))) {
        return;
      }
      debug("Calling " + cmd);
      res = await(cfg.api(cmd)["catch"](function(error) {
        var msg, ref8;
        msg = (ref8 = error.stack) != null ? ref8 : error.toString();
        debug("originate: " + msg);
        return msg;
      }));
      debug("Originate returned", res);
      if (res[0] === '+') {
        debug('caller-connected', _id);
      } else {
        debug.dev('caller-failed', _id);
      }
      return debug('Session state:', data.tags);
    });
    call_to_conference = foot(function(data) {
      var _id, account, calling_number, cmd, destination, endpoint, endpoint_data, is_remote, language, my_reference, name, number_data, params, ref7, ref8, res, sofia, timezone, xref;
      endpoint = data.endpoint, destination = data.destination, _id = data._id;
      debug('Received call-to-conference', data, local_server);
      name = (ref7 = data.conference) != null ? ref7 : data.name;
      if (!((_id != null) && _id.match(/^[\w-]+$/))) {
        return;
      }
      is_remote = await(cfg.is_remote(name, local_server)["catch"](function() {
        return true;
      }));
      if (is_remote) {
        return;
      }
      endpoint_data = await(cfg.prov.get("endpoint:" + endpoint)["catch"](function() {
        return null;
      }));
      if (endpoint_data == null) {
        return;
      }
      if (endpoint_data.disabled || endpoint_data.src_disabled) {
        return;
      }
      account = endpoint_data.account, timezone = endpoint_data.timezone;
      number_data = await(cfg.prov.get("number:" + endpoint)["catch"](function() {
        return {};
      }));
      calling_number = (ref8 = number_data.asserted_number) != null ? ref8 : endpoint.split('@')[0];
      language = data.language;
      if (language == null) {
        language = number_data.language;
      }
      if (language == null) {
        language = endpoint_data.language;
      }
      if (data.timezone != null) {
        if (timezone == null) {
          timezone = data.timezone;
        }
      }
      debug('call-to-conference: Placing call');
      my_reference = new Reference(_id);
      await(my_reference.add_in(["endpoint:" + endpoint, "account:" + account, "number_domain:" + endpoint.number_domain]));
      await(my_reference.set_account(account));
      await(my_reference.set_endpoint(endpoint));
      await(my_reference.set_call_options({
        group_confirm_key: '5',
        group_confirm_file: 'phrase:conference:confirm:5',
        group_confirm_error_file: 'phrase:conference:confirm:5',
        group_confirm_read_timeout: 15000,
        group_confirm_cancel_timeout: false,
        language: language
      }));
      xref = "xref:" + _id;
      params = make_params({
        sip_invite_params: xref,
        sip_invite_to_params: xref,
        sip_invite_contact_params: xref,
        sip_invite_from_params: xref,
        origination_caller_id_number: calling_number
      });
      sofia = "{" + params + "}sofia/" + sofia_profile + "/sip:" + destination + "@" + host + ":" + port;
      cmd = "originate " + sofia + " &conference(" + name + "++flags{})";
      if (!await(elected(_id))) {
        return;
      }
      debug("Calling " + cmd);
      res = await(cfg.api(cmd)["catch"](function(error) {
        var msg, ref9;
        msg = (ref9 = error.stack) != null ? ref9 : error.toString();
        debug("conference: " + msg);
        return msg;
      }));
      return debug("Conference returned", res);
    });
    create_queuer_call = foot(function(body) {
      var Agent, agent, is_remote, queuer;
      queuer = cfg.queuer;
      Agent = queuer.Agent;
      if (!((queuer != null) && (Agent != null))) {
        debug('create-queuer-call: no queuer');
        return;
      }
      if (!((body != null) && (body.agent != null) && (body.destination != null))) {
        debug('create-queuer-call: invalid content', body);
        return;
      }
      agent = new Agent(queuer, body.agent);
      is_remote = await(cfg.is_remote(agent.domain, [local_server, client_server].join('/'))["catch"](function() {
        return true;
      }));
      if (is_remote) {
        debug('create-queuer-call: not handled on this server', body);
        return;
      }
      if (!await(elected(body._id))) {
        return;
      }
      await(queuer.create_egress_call_for(agent, body));
    });
    return {
      place_call: place_call,
      call_to_conference: call_to_conference,
      create_queuer_call: create_queuer_call
    };
  };

  this.server_pre(function() {
    return this.cfg.rr.receive('call:*').filter(function(arg) {
      var deleted, doc, op;
      op = arg.op, doc = arg.doc, deleted = arg.deleted;
      return op === UPDATE && (doc != null) && !deleted;
    }).forEach(function(msg) {
      switch (false) {
        case msg.doc.agent == null:
          return create_queuer_call(msg.doc);
        case msg.doc.conference == null:
          return call_to_conference(msg.doc);
        case msg.doc.endpoint == null:
          return place_call(msg.doc);
      }
    });
  });

  this.notify = function(arg) {
    var H, cfg, socket;
    cfg = arg.cfg, socket = arg.socket;
    H = handler(cfg);
    socket.on('place-call', H.place_call);
    socket.on('call-to-conference', H.call_to_conference);
    socket.on('create-queuer-call', H.create_queuer_call);
    this.register('place-call', 'dial_calls');
    this.register('call-to-conference', 'dial_calls');
    this.register('create-queuer-call', 'dial_calls');
    this.configure({
      dial_calls: true
    });
    return debug('Module Ready');
  };

  this.include = function() {
    var account, destination, options, ref1;
    destination = await(this.reference.get_destination());
    if (destination != null) {
      this.destination = destination;
      await(this.reference.set_destination(null));
      this.session.wait_for_aleg_ack = false;
      this.session.sip_wait_for_aleg_ack = false;
      account = this.reference.get_account();
      if (account != null) {
        await(this["export"]({
          'sip_h_P-Charge-Info': "sip:" + account + "@" + this.cfg.host
        }));
      }
      this.set({
        ringback: (ref1 = this.session.ringback) != null ? ref1 : '%(3000,3000,437,1317)',
        instant_ringback: true
      });
      this.action('playback', 'tone_stream://%(50,50,437,1317);loops=-1');
    }
    options = await(this.reference.get_call_options());
    if (options != null) {
      this.session.call_options = options;
    }
    return this.debug('Ready', {
      destination: destination,
      account: account,
      options: options
    });
  };

}).call(this);
