// Generated by CoffeeScript 1.12.7
(function() {
  var Moment, RedisInterface, SUBSCRIBE, TaggedAgent, TaggedCall, debug, domain_of, hand, now, pkg, queuer, ref, ref1, request, run, sleep,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  this.name = 'huge-play:middleware:client:queuer';

  ref = (require('tangible'))(this.name), debug = ref.debug, hand = ref.hand;

  pkg = {
    name: 'huge-play'
  };

  Moment = require('moment-timezone');

  SUBSCRIBE = require('red-rings/operations').SUBSCRIBE;

  queuer = require('black-metal/queuer');

  request = require('superagent');

  run = require('flat-ornament');

  sleep = function(timeout) {
    return new Promise(function(resolve) {
      return setTimeout(resolve, timeout);
    });
  };

  domain_of = function(key) {
    return key != null ? key.split('@')[1] : void 0;
  };

  now = function(tz) {
    if (tz == null) {
      tz = 'UTC';
    }
    return Moment().tz(tz).format();
  };

  ref1 = require('black-metal/tagged'), TaggedCall = ref1.TaggedCall, TaggedAgent = ref1.TaggedAgent;

  RedisInterface = require('normal-key/interface');

  this.notify = function() {
    var Agent, get_pool, host, ref2;
    ref2 = this.cfg, host = ref2.host, queuer = ref2.queuer;
    if (queuer == null) {
      debug.dev('queuer is not available');
      return;
    }
    Agent = this.cfg.queuer.Agent;
    if (Agent == null) {
      debug.dev('Agent is not available');
      return;
    }
    this.configure({
      dial_calls: true
    });
    this.register('queuer:get-agent-state', 'dial_calls');
    this.register('queuer:log-agent-out', 'dial_calls');
    this.register('queuer:log-agent-in', 'dial_calls');
    this.socket.on('queuer:get-agent-state', hand((function(_this) {
      return function*(key) {
        var agent, is_remote, state;
        is_remote = (yield _this.cfg.is_remote(domain_of(key)));
        if (is_remote !== false) {
          return;
        }
        debug('queuer:get-agent-state', key);
        agent = new Agent(queuer, key);
        state = (yield agent.state()["catch"](function() {
          return null;
        }));
        agent.notify({
          state: state
        });
        debug('queuer:get-agent-state: done', key, state);
      };
    })(this)));
    this.socket.on('queuer:log-agent-out', hand((function(_this) {
      return function*(key) {
        var agent, is_remote;
        is_remote = (yield _this.cfg.is_remote(domain_of(key)));
        if (is_remote !== false) {
          return;
        }
        debug('queue:log-agent-out', key);
        agent = new Agent(queuer, key);
        yield agent.clear_tags();
        yield agent.transition('logout');
        debug('queue:log-agent-out: done', key);
      };
    })(this)));
    this.socket.on('queuer:log-agent-in', hand((function(_this) {
      return function*(key) {
        var agent, broadcast, ctx, i, is_remote, j, len, len1, queue, queues, ref3, skill, skills, tags, timezone;
        is_remote = (yield _this.cfg.is_remote(domain_of(key)));
        if (is_remote !== false) {
          return;
        }
        debug('queue:log-agent-in', key);
        tags = [];
        ref3 = (yield _this.cfg.prov.get("number:" + key)), skills = ref3.skills, queues = ref3.queues, broadcast = ref3.broadcast, timezone = ref3.timezone;
        if (skills != null) {
          for (i = 0, len = skills.length; i < len; i++) {
            skill = skills[i];
            tags.push("skill:" + skill);
          }
        }
        if (queues != null) {
          for (j = 0, len1 = queues.length; j < len1; j++) {
            queue = queues[j];
            tags.push("queue:" + queue);
          }
        }
        if (broadcast) {
          tags.push('broadcast');
        }
        agent = new Agent(queuer, key);
        yield agent.add_tags(tags);
        if (typeof ornaments !== "undefined" && ornaments !== null) {
          ctx = {
            agent: agent,
            timezone: timezone
          };
          yield run.call(ctx, ornaments, _this.ornaments_commands);
        }
        yield agent.accept_onhook();
        yield _this.report({
          state: 'queuer-login',
          source: source,
          fifo: fifo,
          tags: tags
        });
        debug('queue:log-agent-in: done', key);
      };
    })(this)));
    get_pool = (function(_this) {
      return function(name, pool) {
        _this.register("queuer:get-" + name + "-pool", 'dial_calls');
        _this.register("queuer:" + name + "-pool", 'calls');
        return _this.socket.on("queuer:get-" + name + "-pool", hand(function*(domain) {
          var calls, is_remote, notification, result;
          debug("queuer:get-" + name + "-pool", domain);
          is_remote = (yield _this.cfg.is_remote(domain));
          if (is_remote !== false) {
            return;
          }
          calls = (yield pool(domain).calls());
          result = (yield Promise.all(calls.map(function(call) {
            return call.build_notification({});
          })));
          notification = {
            _queuer: true,
            host: host,
            now: Date.now(),
            _in: ["number_domain:" + domain],
            calls: result
          };
          _this.socket.emit("queuer:" + name + "-pool", notification);
          debug("queuer:get-" + name + "-pool: done", domain, notification);
        }));
      };
    })(this);
    get_pool('egress', function(domain) {
      return queuer.egress_pool(domain);
    });
    return get_pool('ingress', function(domain) {
      return queuer.ingress_pool(domain);
    });
  };

  this.server_pre(function() {
    var HugePlayAgent, HugePlayCall, HugePlayReference, Queuer, agent_timeout, api, call_timeout, cfg, host, p, pools_redis_interface, port, profile, prov, ref2, ref3, ref4, ref5;
    cfg = this.cfg;
    cfg.rr.receive('agent:*').forEach(function(msg) {
      var $, agent, broadcast, ctx, i, is_remote, j, key, len, len1, queue, queues, ref2, ref3, ref4, skill, skills, state, tags, timezone;
      switch (false) {
        case msg.op !== SUBSCRIBE:
          if (!($ = (ref2 = msg.key) != null ? ref2.match(/^agent:(\S+)$/) : void 0)) {
            return;
          }
          key = $[1];
          is_remote = await(cfg.is_remote(domain_of(key)));
          if (is_remote !== false) {
            return;
          }
          debug('queuer:get-agent-state', key);
          agent = new Agent(queuer, key);
          state = await(agent.state()["catch"](function() {
            return null;
          }));
          await(agent.notify({
            state: state
          }));
          break;
        case msg.op !== UPDATE:
          if (!($ = (ref3 = msg.id) != null ? ref3.match(/^agent:(\S+)$/) : void 0)) {
            return;
          }
          key = $[1];
          is_remote = await(cfg.is_remote(domain_of(key)));
          if (is_remote !== false) {
            return;
          }
          if (msg.deleted) {
            debug('queue:log-agent-out', key);
            agent = new Agent(queuer, key);
            await(agent.clear_tags());
            await(agent.transition('logout'));
          } else {
            tags = [];
            ref4 = await(cfg.prov.get("number:" + key)), skills = ref4.skills, queues = ref4.queues, broadcast = ref4.broadcast, timezone = ref4.timezone;
            if (skills != null) {
              for (i = 0, len = skills.length; i < len; i++) {
                skill = skills[i];
                tags.push("skill:" + skill);
              }
            }
            if (queues != null) {
              for (j = 0, len1 = queues.length; j < len1; j++) {
                queue = queues[j];
                tags.push("queue:" + queue);
              }
            }
            if (broadcast) {
              tags.push('broadcast');
            }
            agent = new Agent(queuer, key);
            await(agent.add_tags(tags));
            if (typeof ornaments !== "undefined" && ornaments !== null) {
              ctx = {
                agent: agent,
                timezone: timezone
              };
              await(run.call(ctx, ornaments, this.ornaments_commands));
            }
            await(agent.accept_onhook());
          }
      }
    });
    cfg.rr.receive('pool:*').filter(function(arg) {
      var op;
      op = arg.op;
      return op === SUBSCRIBE;
    }).forEach(function(msg) {
      var $, calls, domain, is_remote, name, notification, ref2, result;
      if (!($ = (ref2 = msg.key) != null ? ref2.match(/^pool:(\S+):(ingress|egress)$/) : void 0)) {
        return;
      }
      domain = $[1];
      name = $[2];
      is_remote = await(cfg.is_remote(domain));
      if (is_remote !== false) {
        return;
      }
      calls = await(pool(domain).calls());
      result = await(Promise.all(calls.map(function(call) {
        return call.build_notification({});
      })));
      notification = {
        host: host,
        now: Date.now(),
        calls: result
      };
      cfg.rr.notify(msg.key, "number_domain:" + domain, value);
    });
    HugePlayReference = this.cfg.Reference;
    ref2 = this.cfg, api = ref2.api, prov = ref2.prov, host = ref2.host;
    profile = (ref3 = this.cfg.session) != null ? ref3.profile : void 0;
    p = (ref4 = this.cfg.profiles) != null ? ref4[profile] : void 0;
    if (p != null) {
      port = (ref5 = p.egress_sip_port) != null ? ref5 : p.sip_port + 10000;
    }
    if (!((cfg.local_redis_client != null) && (prov != null) && (profile != null) && (host != null) && (port != null) && (api != null) && (HugePlayReference != null))) {
      this.debug.dev('Missing configuration');
      return;
    }
    call_timeout = 8 * 3600;
    agent_timeout = 12 * 3600;
    HugePlayCall = (function(superClass) {
      extend(HugePlayCall, superClass);

      function HugePlayCall() {
        return HugePlayCall.__super__.constructor.apply(this, arguments);
      }

      HugePlayCall.prototype["interface"] = new RedisInterface(cfg.local_redis_client, call_timeout);

      HugePlayCall.prototype.__api = api;

      HugePlayCall.prototype.profile = pkg.name + "-" + profile + "-egress";

      HugePlayCall.prototype.Reference = HugePlayReference;

      HugePlayCall.prototype.build_notification = function(data) {
        var k, notification, v;
        notification = {
          _queuer: true,
          host: host,
          now: Date.now(),
          domain: this.domain,
          key: this.key,
          id: this.id,
          destination: this.destination,
          call_state: await(this.state()["catch"](function() {
            return null;
          })),
          remote_number: await(this.get_remote_number()["catch"](function() {
            return null;
          })),
          alert_info: await(this.get_alert_info()["catch"](function() {
            return null;
          })),
          reference: await(this.get_reference()["catch"](function() {
            return null;
          })),
          session: await(this.get_session()["catch"](function() {
            return null;
          })),
          answered: await(this.answered()["catch"](function() {
            return null;
          })),
          presenting: await(this.count()["catch"](function() {
            return null;
          })),
          tags: await(this.tags()["catch"](function() {
            return [];
          }))
        };
        for (k in data) {
          if (!hasProp.call(data, k)) continue;
          v = data[k];
          if (!(v != null)) {
            continue;
          }
          switch (k) {
            case 'agent':
            case 'call':
            case 'agent_call':
            case 'remote_call':
              if (typeof v !== 'string') {
                v = v.key;
              }
          }
          if (notification[k] == null) {
            notification[k] = v;
          }
        }
        return notification;
      };

      HugePlayCall.prototype.report = function(data) {
        var notification;
        debug('call.report', data);
        notification = await(this.build_notification(data));
        cfg.statistics.emit('queuer', notification);
        cfg.rr.notify("call:" + notification.id, "call:" + notification.id, notification);
        debug('call.report: send', notification);
        return notification;
      };

      return HugePlayCall;

    })(TaggedCall);
    HugePlayAgent = (function(superClass) {
      extend(HugePlayAgent, superClass);

      function HugePlayAgent() {
        return HugePlayAgent.__super__.constructor.apply(this, arguments);
      }

      HugePlayAgent.prototype["interface"] = new RedisInterface(cfg.local_redis_client, agent_timeout);

      HugePlayAgent.prototype.new_call = function(data) {
        return new HugePlayCall(cfg.queuer, this.domain, data);
      };

      HugePlayAgent.prototype.notify = function(data) {
        var agent_name, event, notification, offhook, old_state, reason, state;
        debug('agent.notify', this.key, data);
        old_state = data.old_state, state = data.state, event = data.event, reason = data.reason;
        notification = {
          _queuer: true,
          _in: ["endpoint:" + this.key, "number:" + this.key, "number_domain:" + this.domain],
          _notify: true,
          host: host,
          now: Date.now(),
          state: state,
          old_state: old_state,
          event: event,
          reason: reason,
          agent: this.key,
          number: this.number,
          number_domain: this.domain,
          dialplan: 'centrex',
          missed: await(this.get_missed()["catch"](function() {
            return 0;
          })),
          count: await(this.count()["catch"](function() {
            return 0;
          }))
        };
        notification.tags = await(this.tags()["catch"](function() {
          return [];
        }));
        agent_name = await((this.get('name'))["catch"](function() {
          return null;
        }));
        if (agent_name != null) {
          notification.agent_name = agent_name;
        }
        offhook = await(this.get_offhook_call()["catch"](function() {
          return null;
        }));
        if (offhook) {
          notification.offhook = true;
        } else {
          notification.offhook = false;
        }
        if (data.call != null) {
          notification = await(data.call.report(notification));
        } else {
          cfg.statistics.emit('queuer', notification);
        }
        cfg.rr.notify("agent:" + notification.agent, "agent:" + notification.agent, notification);
        debug('agent.notify: done', this.key, notification);
      };

      HugePlayAgent.prototype.create_egress_call = function(body) {
        var _id, account, call, call_data, endpoint, options, queuer_webhook, ref6, reference, tags, timezone;
        debug('create_egress_call', this.domain, body);
        if (this.number_domain_data == null) {
          this.number_domain_data = await(prov).get("number_domain:" + this.domain)["catch"](function(error) {
            return null;
          });
        }
        if (this.number_domain_data == null) {
          debug('create_egress_call: missing number-domain', this.domain);
          return;
        }
        ref6 = this.number_domain_data, account = ref6.account, queuer_webhook = ref6.queuer_webhook, timezone = ref6.timezone;
        if (timezone == null) {
          timezone = null;
        }
        await(this.set('timezone', timezone));
        if (account == null) {
          debug('create_egress_call: no account', this.domain);
          return null;
        }
        if (body == null) {
          if (queuer_webhook == null) {
            debug('create_egress_call: no queuer_webhook', this.domain);
            return null;
          }
          tags = await(this.tags());
          options = {
            key: this.key,
            number: this.number,
            domain: this.domain,
            tags: tags
          };
          debug('create_egress_call: send request', options);
          body = await(request).post(queuer_webhook).send(options).body;
        }
        if (body.tags == null) {
          body.tags = [];
        }
        if (!((body.destination != null) && (body.tags != null) && (body.tags.length != null))) {
          debug('create_egress_call: incomplete response', this.domain, body);
          return null;
        }
        body.tags.push('queuer');
        debug('create_egress_call: creating call', this.domain, body);
        body.tags.push('egress');
        body.tags.push("number_domain:" + this.domain);
        endpoint = this.key;
        reference = new HugePlayReference();
        _id = reference.id;
        await(reference.add_in(["endpoint:" + endpoint, "number:" + endpoint, "account:" + account, "number_domain:" + this.domain]));
        await(reference.set_endpoint(endpoint));
        await(reference.set_account(account));
        await(reference.set_destination(body.destination));
        await(reference.set_source(this.number));
        await(reference.set_domain(host + ":" + port));
        await(reference.set_block_dtmf(true));
        call_data = {
          uuid: 'create-egress-call',
          session: _id + "-create-egress-call",
          reference: _id,
          start_time: now(timezone),
          source: this.number,
          destination: body.destination,
          timezone: timezone,
          timestamp: now(timezone),
          host: host,
          type: 'call',
          event: 'create-egress-call'
        };
        call = this.new_call({
          destination: _id
        });
        await(call.save());
        await(call.set_remote_number(body.destination));
        await(call.set_tags(body.tags));
        await(call.set('timezone', timezone));
        this.notify(call_data);
        debug('create_egress_call: complete');
        return call;
      };

      return HugePlayAgent;

    })(TaggedAgent);
    pools_redis_interface = new RedisInterface(cfg.local_redis_client, agent_timeout);
    Queuer = queuer(pools_redis_interface, {
      Agent: HugePlayAgent,
      Call: HugePlayCall
    });
    this.cfg.queuer = new Queuer(this.cfg);
  });

  this.include = function() {
    var Agent, Call, local_server, ref2, uuid;
    if (await(this.reference.get_block_dtmf())) {
      await(this.action('block_dtmf'));
    }
    queuer = this.cfg.queuer;
    if (queuer == null) {
      return;
    }
    ref2 = this.cfg.queuer, Agent = ref2.Agent, Call = ref2.Call;
    if (!((Agent != null) && (Call != null))) {
      return;
    }
    uuid = this.call.uuid;
    this.queuer_call = function(id) {
      var domain, queuer_call;
      domain = this.session.number_domain;
      if (id == null) {
        id = uuid;
      }
      this.debug('queuer_call', id, domain);
      queuer_call = new Call(queuer, domain, {
        id: id
      });
      await(queuer_call.save());
      await(queuer_call.set_session(this.session._id));
      await(queuer_call.set_reference(this.session.reference));
      return queuer_call;
    };
    local_server = [this.session.local_server, this.session.client_server].join('/');
    this.queuer_login = function(source, name, fifo, tags, ornaments) {
      var agent;
      if (tags == null) {
        tags = [];
      }
      this.debug('queuer_login', source);
      agent = new Agent(queuer, source);
      await(agent.set('name', name));
      await(agent.add_tags(tags));
      if ((fifo != null ? fifo.full_name : void 0) != null) {
        await(agent.add_tag("queue:" + fifo.full_name));
      }
      if (ornaments != null) {
        this.agent = agent;
        await(run.call(this, ornaments, this.ornaments_commands));
      }
      await(agent.accept_onhook());
      await(this.report({
        state: 'queuer-login',
        source: source,
        fifo: fifo,
        tags: tags
      }));
      return agent;
    };
    this.queuer_leave = function(source, fifo) {
      var agent;
      this.debug('queuer_leave', source);
      agent = new Agent(queuer, source);
      if ((fifo != null ? fifo.full_name : void 0) != null) {
        await(agent.del_tag("queue:" + fifo.full_name));
      }
      await(this.report({
        state: 'queuer-leave',
        source: source,
        fifo: fifo
      }));
      return agent;
    };
    this.queuer_logout = function(source, fifo) {
      var agent;
      this.debug('queuer_logout', source);
      agent = new Agent(queuer, source);
      if ((fifo != null ? fifo.full_name : void 0) != null) {
        await(agent.del_tag("queue:" + fifo.full_name));
      }
      await(agent.clear_tags());
      await(agent.transition('logout'));
      await(this.report({
        state: 'queuer-logout',
        source: source,
        fifo: fifo
      }));
      return agent;
    };
    return this.queuer_offhook = function(source, name, arg, fifo, tags) {
      var agent, call, uuid;
      uuid = arg.uuid;
      if (tags == null) {
        tags = [];
      }
      this.debug('queuer_offhook', source, uuid, fifo);
      agent = new Agent(queuer, source);
      await(agent.set('name', name));
      agent.clear_tags();
      await(agent.add_tags(tags));
      if ((fifo != null ? fifo.full_name : void 0) != null) {
        await(agent.add_tag("queue:" + fifo.full_name));
      }
      call = await(agent.accept_offhook(uuid));
      if (call == null) {
        return;
      }
      await(call.set_session(this.session._id));
      await(this.report({
        state: 'queuer-offhook',
        source: source,
        fifo: fifo,
        tags: tags
      }));
      return agent;
    };
  };

}).call(this);
